routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
        return view('welcome');
    })->name('welcome');

Auth::routes();

Route::get('/preferences/{preference}', 'PreferencesController@show')->name('preferences.show');
Route::get('/preferences/{preference}/edit', 'PreferencesController@edit')->name('preferences.edit');
Route::patch('/preferences/{preference}', 'PreferencesController@update')->name('preferences.update');

Route::resource(	'jobs/{job}/materials',
					'JobMaterialsController',
					['names' => [
    						'index' => 'jobs.materials.index',
    						'create' => 'jobs.materials.create',
    						'store' => 'jobs.materials.store',
    						'show' => 'jobs.materials.show',
    						'edit' => 'jobs.materials.edit',
    						'update' => 'jobs.materials.update',
    						'destroy' => 'jobs.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/labour',
					'JobLabourController',
					['names' => [
    						'index' => 'jobs.labour.index',
    						'create' => 'jobs.labour.create',
    						'store' => 'jobs.labour.store',
    						'show' => 'jobs.labour.show',
    						'edit' => 'jobs.labour.edit',
    						'update' => 'jobs.labour.update',
    						'destroy' => 'jobs.labour.destroy',
						]
					]);

Route::post('jobs/{job}/invoices/{invoice}/toggle-send', 'JobInvoicesController@toggleSend')->name('jobs.invoices.toggleSend');
Route::get('jobs/{job}/invoices/{invoice}/send/{details}', 'JobInvoicesController@send')->name('jobs.invoices.send');

Route::get('jobs/{job}/invoices/{invoice}/toggle-pay', 'JobInvoicesController@togglePay')->name('jobs.invoices.togglePay');

Route::get('jobs/{job}/invoices/{invoice}/print', 'JobInvoicesController@print')->name('jobs.invoices.print');
Route::post('jobs/{job}/invoices/{invoice}/print', 'JobInvoicesController@print')->name('jobs.invoices.print');

Route::resource(	'jobs/{job}/invoices',
					'JobInvoicesController',
					['names' => [
    						'index' => 'jobs.invoices.index',
    						'create' => 'jobs.invoices.create',
    						'store' => 'jobs.invoices.store',
    						'show' => 'jobs.invoices.show',
    						'edit' => 'jobs.invoices.edit',
    						'update' => 'jobs.invoices.update',
    						'destroy' => 'jobs.invoices.destroy',
						]
					]);

Route::resource(	'jobs/{job}/invoices/{invoice}/materials',
					'JobInvoicesMaterialsController',
					['names' => [
    						'index' => 'jobs.invoices.materials.index',
    						'create' => 'jobs.invoices.materials.create',
    						'store' => 'jobs.invoices.materials.store',
    						'show' => 'jobs.invoices.materials.show',
    						'edit' => 'jobs.invoices.materials.edit',
    						'update' => 'jobs.invoices.materials.update',
    						'destroy' => 'jobs.invoices.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/invoices/{invoice}/labour',
					'JobInvoicesLabourController',
					['names' => [
    						'index' => 'jobs.invoices.labour.index',
    						'create' => 'jobs.invoices.labour.create',
    						'store' => 'jobs.invoices.labour.store',
    						'show' => 'jobs.invoices.labour.show',
    						'edit' => 'jobs.invoices.labour.edit',
    						'update' => 'jobs.invoices.labour.update',
    						'destroy' => 'jobs.invoices.labour.destroy',
						]
					]);

Route::post('jobs/{job}/proposals/{proposal}/toggle-send', 'JobProposalsController@toggleSend')->name('jobs.proposals.toggleSend');
Route::post('jobs/{job}/proposals/{proposal}/send', 'JobProposalsController@send')->name('jobs.proposals.send');
Route::get('jobs/{job}/proposals/{proposal}/change-status/{status}', 'JobProposalsController@changeStatus')->name('jobs.proposals.changeStatus');

Route::get('jobs/{job}/proposals/{proposal}/print', 'JobProposalsController@print')->name('jobs.proposals.print');

Route::resource(    'jobs/{job}/proposals/{proposal}/scopes',
                    'JobProposalsScopesController',
                    ['names' => [
                            'index' => 'jobs.proposals.scopes.index',
                            'create' => 'jobs.proposals.scopes.create',
                            'store' => 'jobs.proposals.scopes.store',
                            'show' => 'jobs.proposals.scopes.show',
                            'edit' => 'jobs.proposals.scopes.edit',
                            'update' => 'jobs.proposals.scopes.update',
                            'destroy' => 'jobs.proposals.scopes.destroy',
                        ]
                    ]);

Route::resource(	'jobs/{job}/proposals',
					'JobProposalsController',
					['names' => [
    						'index' => 'jobs.proposals.index',
    						'create' => 'jobs.proposals.create',
    						'store' => 'jobs.proposals.store',
    						'show' => 'jobs.proposals.show',
    						'edit' => 'jobs.proposals.edit',
    						'update' => 'jobs.proposals.update',
    						'destroy' => 'jobs.proposals.destroy',
						]
					]);

Route::resource(	'jobs/{job}/proposals/{proposal}/materials',
					'JobProposalsMaterialsController',
					['names' => [
    						'index' => 'jobs.proposals.materials.index',
    						'create' => 'jobs.proposals.materials.create',
    						'store' => 'jobs.proposals.materials.store',
    						'show' => 'jobs.proposals.materials.show',
    						'edit' => 'jobs.proposals.materials.edit',
    						'update' => 'jobs.proposals.materials.update',
    						'destroy' => 'jobs.proposals.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/proposals/{proposal}/labour',
					'JobProposalsLabourController',
					['names' => [
    						'index' => 'jobs.proposals.labour.index',
    						'create' => 'jobs.proposals.labour.create',
    						'store' => 'jobs.proposals.labour.store',
    						'show' => 'jobs.proposals.labour.show',
    						'edit' => 'jobs.proposals.labour.edit',
    						'update' => 'jobs.proposals.labour.update',
    						'destroy' => 'jobs.proposals.labour.destroy',
						]
					]);

Route::resource('/jobs', 'JobController');

Route::view('/calculator', 'calculator')->name('calculator');

Route::get('/home', 'HomeController@index')->name('home');

/*
ACTIONS HANDLED BY RESOURCE CONTROLLER
VERB		URI						ACTION		ROUTE NAME
GET			/photos					index		photos.index
GET			/photos/create			create		photos.create
POST		/photos					store		photos.store
GET			/photos/{photo}			show		photos.show
GET			/photos/{photo}/edit	edit		photos.edit
PUT/PATCH	/photos/{photo}			update		photos.update
DELETE		/photos/{photo}			destroy		photos.destroy
*/

app/Proposals.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Proposals extends Model
{
    protected $fillable = [
        'job_id',
        'sent',
        'status',
    ];
    //
    public function materials()
    {
    	return $this->morphMany( Materials::class, 'materialable');
    }

    public function labour()
    {
    	return $this->morphMany( Labour::class, 'labourable');
    }
    public function job()
    {
    	return $this->belongsTo( Job::class );
    }

    /**
     * Proposals has many Scopes.
     *
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function scopes()
    {
        // hasMany(RelatedModel, foreignKeyOnRelatedModel = proposals_id, localKey = id)
        return $this->hasMany(Scopes::class);
    }

    public function toggleSent()
    {
        $this->sent = !$this->sent;

        return $this;
    }
}

app/Scopes.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Scopes extends Model
{
    //
    protected $fillable = [
        'proposal_id',
        'description',
    ];


    /**
     * Scopes belongs to Proposals.
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function proposal()
    {
        // belongsTo(RelatedModel, foreignKey = proposals_id, keyOnRelatedModel = id)
        return $this->belongsTo(Proposals::class);
    }
}

resources/views/jobs/proposals/scopes/create.blade.php
@extends('layouts.admin')

@section('page-title', 'Add Scope')

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.index') }}">Jobs</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.show', $proposal->job->id) }}">{{ $proposal->job->number }}</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.proposals.show', [$proposal->job->id, $proposal->id]) }}">Proposal</a></li>
		<li class="breadcrumb-item active">New Scope</li>
	</ol>
@endsection

@section('page-content')
	<p class="lead">
		Enter each new scope description on a new line.
	</p>
	<form 	action="{{ route('jobs.proposals.scopes.store', [$proposal->job->id, $proposal->id]) }}"
			method="POST"
			enctype="multipart/form-data">
		{{ csrf_field() }}
		<div class="form-group">
			<label 	for="scopeDescription" 
					{{ $errors->has('description') ? 'text-danger' :'' }}>
				Description
			</label>
			<textarea	name="description"
						class="form-control {{ $errors->has('description') ? 'is-invalid' :'' }}"
						id="scopeDescription"
						autocomplete="off"
						rows="5"
						min="10"
						required>{{ old('description') }}</textarea>
			<small class="form-text {{ $errors->has('description') ? 'invalid-feedback' :'' }}">
				Required. At least 10 characters.
			</small>
		</div>

		<button class="btn btn-primary" type="submit">Save New</button>
		<a class="btn btn-outline-primary" href="{{ route('jobs.proposals.show', [$proposal->job->id, $proposal->id]) }}#scope">
			Cancel
		</a>
	</form>
@stop

resources/views/jobs/proposals/scopes/edit.blade.php
@extends('layouts.admin')

@section('page-title', 'Edit Scope')

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.index') }}">Jobs</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.show', $proposal->job->id) }}">{{ $proposal->job->number }}</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.proposals.show', [$proposal->job->id, $proposal->id]) }}">Proposal</a></li>
		<li class="breadcrumb-item active">Edit Scope</li>
	</ol>
@endsection

@section('page-content')
	<p class="lead">
		All new lines will be ignored.
	</p>
	<form 	action="{{ route('jobs.proposals.scopes.update', [$proposal->job->id, $proposal->id, $scope->id]) }}"
			method="POST"
			enctype="multipart/form-data">
		{{ csrf_field() }}
		{{ method_field('PATCH') }}
		<div class="form-group">
			<label 	for="scopeDescription" 
					{{ $errors->has('description') ? 'text-danger' :'' }}>
				Description
			</label>
			<textarea	name="description"
						class="form-control {{ $errors->has('description') ? 'is-invalid' :'' }}"
						id="scopeDescription"
						autocomplete="off"
						rows="5"
						min="10"
						required>{{ old('description', $scope->description) }}</textarea>
			<small class="form-text {{ $errors->has('description') ? 'invalid-feedback' :'' }}">
				Required. At least 10 characters.
			</small>
		</div>
		<div class="form-group">
			<button class="btn btn-primary" type="submit">Update</button>
			<a class="btn btn-outline-primary" href="{{ route('jobs.proposals.show', [$proposal->job->id, $proposal->id]) }}#scope">
				Cancel
			</a>
		</div>
	</form>
	<div class="form-group">
		<form 	method="POST"
				id="deleteScope"
				action="{{ route('jobs.proposals.scopes.destroy', [ $proposal->job->id, $proposal->id, $scope->id ]) }}"
				enctype="multipart/data">
			{{ csrf_field() }}
			{{ method_field('DELETE') }}
		</form>
		<button 	data-toggle="modal"
					type="button"
					data-target="#confirmModal"
					data-titletext = "Delete Scope"
					data-formid="scope-{{ $scope->id }}"
					class="btn btn-outline-danger btn-block">
			Delete
		</button>
	</div>
@stop

resources/views/jobs/proposals/scopes/index.blade.php
@extends('layouts.admin')

@section('page-title', 'Jobs')

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item active">Jobs</li>
	</ol>
@endsection

@section('page-content')
	<a class="btn btn-primary btn-block" href="{{ route('jobs.materials.create', $job->id) }}">
		New Material
	</a>

	<div class="modal" tabindex="-1" role="dialog" aria-hidden="true" id="confirmModal">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title">Modal title</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<p>Are you sure you want to delete this job?</p>
				</div>
				<div class="modal-footer">
					<button 	type="button" 
								id="btnModalConfirm" 
								class="btn btn-primary">
						Yes
					</button>
					<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>
@stop

@section( 'page-script' )
<script>
	$('#confirmModal').on('show.bs.modal', function (event) {
		var button = $(event.relatedTarget); // Button that triggered the modal
		var record = button.data('record'); // Extract info from data-* attributes
		var number = button.data('number');
		// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
		// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
		var modal = $(this);
		modal.find('.modal-title').text('Deleting Job ' + number);
		
		$('#btnModalConfirm').click( function() {

			$('#job-' + record).submit();
		});

	})
</script>
@endsection

resources/views/jobs/proposals/scopes/show.blade.php
@extends('layouts.admin')

@section('page-title', 'Job ' .$job->number .' Details')

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.index') }}">Jobs</a></li>
		<li class="breadcrumb-item active">{{ $job->number }} Details</li>
	</ol>
@endsection

@section('page-content')
	<div class="row">
		<div class="col-md-8">
			<div class="card my-3">
				<a href="https://www.google.ca/maps/place/{{ urlencode( $job->address ) }}" rel="noreferrer" rel="noopener" target="_blank">
				<img 	class="card-img-top"
						src="https://maps.googleapis.com/maps/api/staticmap?size=512x512&scale=2&maptype=roadmap\&markers=size:mid%7Ccolor:red%7C{{ urlencode( $job->address ) }}&key=AIzaSyC3uTBSLuDdTdq_XSYPXhNR5Y1EwiPClFw" alt="Address">
				</a>
				<div class="card-header">
					<div class="h4 mb-1">
						{{ $job->number }}
					</div>
					<small class="text-muted">{{ $job->created_at->diffForHumans() }}</small>
				</div>
				@if( !empty( $job->note ) )
				<div class="card-body">
					<small>
						<pre class="card-text text-muted">{{ $job->note }}</pre>
					</small>
				</div>
				@endif
				<ul class="list-group list-group-flush">
					@if( !empty( $job->name ) )
					<li class="list-group-item">{{ $job->name }}</li>
					@endif
					@if( !empty( $job->address ) )
					<li class="list-group-item">
						<a href="https://www.google.ca/maps/place/{{ urlencode( $job->address ) }}" rel="noreferrer" rel="noopener" target="_blank">
							{{ $job->address }}
						</a>
					</li>
					@endif
					@if( !empty( $job->phone ) )
					<li class="list-group-item">
						<a href="tel:{{ $job->phone }}">
							{{ $job->formatPhoneNumber( $job->phone ) }}
						</a>
						@if( !empty( $job->extension ) )
						<small class="text-muted">
							ext: {{ $job->extension }}
						</small>
						@endif
					</li>
					@endif
					@if( !empty( $job->email ) )
					<li class="list-group-item">
						<a href="mailto:{{ $job->email }}">
							{{ $job->email }}
						</a>
					</li>
					@endif
					<li class="list-group-item">{{ ($job->finished ? 'Finished' : 'Not Finished') }}</li>
				</ul>
				<div class="card-footer">
					<a class="btn btn-outline-primary" href="{{ route( 'jobs.edit', $job->id ) }}">
						<i class="fa fa-pencil" aria-hidden="true"></i>
						Edit
					</a>
					<button 	type="button" 
								data-toggle="modal"
								data-target="#confirmModal"
								data-record="{{ $job->id }}"
								data-number="{{ $job->number }}"
								class="btn btn-outline-danger">
						<i class="fa fa-trash" aria-hidden="true"></i>
						Delete
					</button>
					<form 	id="deleteJob"
							action="{{ route('jobs.destroy', $job->id) }}"
							method="POST"
							enctype="multipart/form-data">
						{{ csrf_field() }}
						{{ method_field( 'DELETE' ) }}
					</form>
				</div>
			</div>
		</div>
		<div class="col-md-4">
			<div class="row">
				<div class="col-12">
					<div class="card my-3">
						<div class="card-header">
							<div class="h5 mb-1">
								Proposals
							</div>
						</div>
						<ul class="list-group list-group-flush">
							<li class="list-group-item list-group-item-warning">
								<div class="list-group-item-heading">
									Proposal 1
									<a 	class="btn btn-outline-primary btn-sm float-right mx-auto"
										href="#">
										Edit
									</a>
								</div>
								<small class="text-muted">
									$370 Labor, $422 Material = $792
								</small>
								-
								<small class="text-danger">
									Refused
								</small>
							</li>
							<li class="list-group-item list-group-item-success">
								<div class="list-group-item-heading">
									Proposal 2
									<a 	class="btn btn-outline-primary btn-sm float-right"
										href="#">
										Edit
									</a>
								</div>
								<small class="text-muted">
									$380 Labor, $422 Material = $802
								</small>
								-
								<small class="text-success">
									Approved
								</small>
							</li>
						</ul>
						<div class="card-footer">
							<a 	class="btn btn-outline-primary btn-block" 
								href="#">
								New
							</a>
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-12">
					<div class="card my-3">
						<div class="card-header">
							<div class="h5 mb-1">
								Invoices
							</div>
						</div>
						<ul class="list-group list-group-flush">
							<li class="list-group-item list-group-item-warning">
								<div class="list-group-item-heading">
									Invoice 1
									<a 	class="btn btn-outline-primary btn-sm float-right"
										href="#">
										Edit
									</a>
								</div>
								<small class="text-muted">
									$380 Labor, $422 Material = $802
								</small>
								-
								<small class="text-danger">
									Unsent
								</small>
							</li>
						</ul>
						<div class="card-footer">
							<a 	class="btn btn-outline-primary btn-block" 
								href="#">
								New
							</a>
						</div>
					</div>
				</div>

			</div>

			<div class="row">
				<div class="col-12">
					<div class="card my-3">
						<div class="card-header">
							<div class="h5 mb-1">
								Actual
							</div>
						</div>
						<ul class="list-group list-group-flush">
							<li class="list-group-item list-group-item-info">
								<div class="list-group-item-heading">
									Material
								</div>
							</li>
							<li class="list-group-item p-0">
								<table class="table table-sm mb-0">
									<tbody>
										<tr>
											<td class="small text-right" scope="row">
												1
											</td>
											<td class="small">
												Roll
											</td>
											<td class="small">
												Flatstock-White
											</td>
											<td class="small text-right">
												@&nbsp;$125.22
											</td>
											<th class="small text-right">
												=&nbsp;$125.22
											</th>
										</tr>
										<tr>
											<td class="small text-right" scope="row">
												3
											</td>
											<td class="small">
												Boxes
											</td>
											<td class="small">
												Wood Screws
											</td>
											<td class="small text-right">
												@ $17.53
											</td>
											<th class="small text-right">
												= $52.59
											</th>
										</tr>
										<tr>
											<td class="small text-right" scope="row">
												2
											</td>
											<td class="small">
												Boxes
											</td>
											<td class="small">
												Siding-Mocha
											</td>
											<td class="small text-right">
												@ $97.73
											</td>
											<th class="small text-right">
												= $194.00
											</th>
										</tr>
										<tr class="table-dark">
											<th class="small text-right" colspan="4">
												Total
											</th>
											<th class="small text-right">
												$371.81
											</th>
										</tr>
									</tbody>
								</table>
								<a 	class="btn btn-outline-info btn-block btn-sm mb-3" 
									href="{{ route('materials.create', [ 'job', $job->id ] ) }}">
									New
								</a>
								<hr>
							</li>
							<li class="list-group-item list-group-item-info">
								<div class="list-group-item-heading">
									Labour
								</div>
							</li>
							<li class="list-group-item p-0">
								<table class="table table-sm mb-0">
									<tbody>
										<tr>
											<td class="small text-right" scope="row">
												3&nbsp;hrs
											</td>
											<td class="small">
												Clearing Debris
											</td>
											<td class="small">
												@&nbsp;$15/hr
											</td>
											<th class="small text-right">
												=&nbsp;$45
											</th>
										</tr>
										<tr>
											<td class="small text-right" scope="row">
												0.5&nbsp;hrs
											</td>
											<td class="small">
												Flashing Repair
											</td>
											<td class="small">
												@&nbsp;$40/hr
											</td>
											<th class="small text-right">
												=&nbsp;$20
											</th>
										</tr>
										<tr class="table-dark">
											<th class="small text-right" colspan="3">
												Total
											</th>
											<th class="small text-right">
												$65
											</th>
										</tr>
									</tbody>
								</table>
								<a 	class="btn btn-outline-info btn-block btn-sm" 
									href="#">
									New
								</a>
							</li>
						</ul>
					</div>
				</div>

			</div>
		</div>
	</div>
	<div class="modal" tabindex="-1" role="dialog" aria-hidden="true" id="confirmModal">
		<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title">Deleting Job {{ $job->number }}</h5>
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
			</div>
			<div class="modal-body">
				<p>Are you sure you want to delete this job?</p>
			</div>
			<div class="modal-footer">
				<button 	type="button" 
							id="btnModalConfirm" 
							class="btn btn-primary">
					Yes
				</button>
				<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			</div>
		</div>
		</div>
	</div>
@stop

@section( 'page-script' )
<script>
	$('#confirmModal').on('show.bs.modal', function (event) {
				
		$('#btnModalConfirm').click( function() {

			$('#deleteJob').submit();
		});

	})
</script>
@endsection